<#macro panelLogic item>
<@compress single_line=true>
<#if item.getLogicType() == 'GROUP'>
<#if item.isNotMode()>
!(
</#if>
<#if item.getPSPanelItemLogics()??>
<#list item.getPSPanelItemLogics() as subLogic>
<#if subLogic_index gt 0>
<#if item.getGroupOP() == 'AND'> 
&&
</#if>
<#if item.getGroupOP() == 'OR'>
||
</#if>
</#if>
<@panelLogic subLogic/>
</#list>
</#if>
<#if item.isNotMode()>
)
</#if>
<#elseif item.getLogicType() == 'SINGLE'>
this.$verify.testCond(_${item.getDstModelField()?lower_case}, "${item.getCondOp()}", "${item.getValue()}")
</#if>
</@compress>
</#macro>
<#macro getPanelItemLogic panelItem>
    <#if panelItem.getPSPanelItemGroupLogic('ITEMBLANK')??>
    <#assign ITEMBLANK = panelItem.getPSPanelItemGroupLogic('ITEMBLANK')/>
    if (Object.is(name, '')<#if ITEMBLANK.getRelatedItemNames()??><#list ITEMBLANK.getRelatedItemNames() as detailName> || Object.is(name, '${detailName}')</#list></#if>) {
        let ret = true;
        <#if ITEMBLANK.getRelatedItemNames()??>
        <#list ITEMBLANK.getRelatedItemNames() as detailName>
        let _${detailName} = '';
        if (index || index === 0) {
            _${detailName} = this.layoutData[`${detailName}<#noparse>_${index}</#noparse>`];
        } else {
            _${detailName} = this.layoutData['${detailName}'];
        }
        </#list>
        </#if>
        if (<@panelLogic ITEMBLANK/>) {
            ret = false;
        }
        if (index || index === 0) {
            this.layoutModelDetails[`${panelItem.name}<#noparse>_${index}</#noparse>`].required = ret;
        } else {
            this.layoutModelDetails['${panelItem.name}'].required = ret;
        }
    }
    </#if>
    <#if panelItem.getPSPanelItemGroupLogic('ITEMENABLE')??>
    <#assign ITEMENABLE = panelItem.getPSPanelItemGroupLogic('ITEMENABLE')/>
    if (Object.is(name, '')<#if ITEMENABLE.getRelatedItemNames()??><#list ITEMENABLE.getRelatedItemNames() as detailName> || Object.is(name, '${detailName}')</#list></#if>) {
        let ret = false;
        <#if ITEMENABLE.getRelatedItemNames()??>
        <#list ITEMENABLE.getRelatedItemNames() as detailName>
        let _${detailName} = '';
        if (index || index === 0) {
            _${detailName} = this.layoutData[`${detailName}<#noparse>_${index}</#noparse>`];
        } else {
            _${detailName} = this.layoutData['${detailName}'];
        }
        </#list>
        </#if>
        if (<@panelLogic ITEMENABLE/>) {
            ret = true;
        }
        if (index || index === 0) {
            this.layoutModelDetails[`${panelItem.name}<#noparse>_${index}</#noparse>`].disabled = !ret;
        } else {
            this.layoutModelDetails['${panelItem.name}'].disabled = !ret;
        }
    }
    </#if>
    <#if panelItem.getPSPanelItemGroupLogic('PANELVISIBLE')??>
    <#assign PANELVISIBLE = panelItem.getPSPanelItemGroupLogic('PANELVISIBLE')/>
    if (Object.is(name, '')<#if PANELVISIBLE.getRelatedItemNames()??><#list PANELVISIBLE.getRelatedItemNames() as detailName> || Object.is(name, '${detailName}')</#list></#if>) {
        let ret = false;
        <#if PANELVISIBLE.getRelatedItemNames()??>
        <#list PANELVISIBLE.getRelatedItemNames() as detailName>
        let _${detailName} = '';
        if (index || index === 0) {
            _${detailName} = this.layoutData[`${detailName}<#noparse>_${index}</#noparse>`];
        } else {
            _${detailName} = this.layoutData['${detailName}'];
        }
        </#list>
        </#if>
        if (<@panelLogic PANELVISIBLE/>) {
            ret = true;
        }
        if (index || index === 0) {
            this.layoutModelDetails[`${panelItem.name}<#noparse>_${index}</#noparse>`].visible = ret;
        } else {
            this.layoutModelDetails['${panelItem.name}'].visible = ret;
        }
    }
    </#if>
</#macro>